routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['prefix'=>'admin','namespace'=>'Admin', 'middleware' => ['admin']],function(){
    Route::get('home', 'AdminController@home')->name('admin_home');

    Route::resource('posts', 'PostController');
    Route::get('posts-show', 'PostController@anyDatatables')->name('datatable_post');
    Route::get('posts-visiable', 'PostController@visiable')->name('visable_post');

    Route::resource('pages', 'PageController');
    Route::get('pages-show', 'PageController@anyDatatables')->name('show_page');

    Route::resource('filter', 'FilterController');

    Route::resource('comments', 'CommentController');
    Route::get('comments-show', 'CommentController@anyDatatables')->name('datatable_comment');
    Route::post('comments-random', 'CommentController@randomCommentFromForm')->name('randomCommentFromForm');
    Route::get('comments-random', 'CommentController@randomComment')->name('randomComment');

    Route::resource('contact', 'ContactController');

    Route::resource('products', 'ProductController');
    Route::get('products-show', 'ProductController@anyDatatables')->name('datatable_product');
    Route::get('export-products', 'ProductController@exportToExcel')->name('exportProducts');
    Route::post('import-products', 'ProductController@importToExcel')->name('importProducts');
    Route::post('get-product-getfly', 'ProductController@getProductGetfly')->name('getProductGetfly');

    Route::resource('templates', 'TemplateController');
    Route::resource('type-information', 'TypeInformationController');
    Route::resource('type-input', 'TypeInputController');
    Route::resource('type-sub-post', 'TypeSubPostController');
    Route::resource('categories', 'CategoryController');
    Route::resource('category-products', 'CategoryProductController');
    Route::get('get-cate-product-getfly', 'CategoryProductController@getCateProductGetfly')->name('getCateProductGetfly');

    Route::group(['prefix' => '{typePost}'], function($typePost){
        // Files
        Route::resource('sub-posts', 'SubPostController');
        Route::get('sub-posts-show', 'SubPostController@anyDatatables')->name('datatable_sub_posts');
    });
    Route::resource('information', 'InformationController', ['only' => [
        'index', 'store'
    ]]);
    Route::get('information/general', 'InformationController@generalCreate')->name('information-general');
    Route::post('information/general-store', 'InformationController@generalStore')->name('information-store');

    Route::resource('menus', 'MenuController');
    Route::resource('users', 'UserController');

    Route::resource('subcribe-email', 'SubcribeEmailController');
    Route::get('subcribe-email-anyDatabase', 'SubcribeEmailController@anyDatatables')->name('subcribe-email-data');
    Route::post('group-mail/create', 'GroupMailController@store')->name('group_mail.create');
    Route::delete('group-mail/{groupMail}', 'GroupMailController@destroy')->name('group_mail.destroy');
    Route::post('send-mail', 'SubcribeEmailController@send')->name('subcribe-email_send');

    Route::get('hinh-thuc-thanh-toan', 'OrderController@setting')->name('method_payment');
    Route::post('cap-nhat-ngan-hang', 'OrderController@updateBank')->name('bank');
    Route::delete('quan-li-ngan-hang/{orderBanks}', 'OrderController@deleteBank')->name('orderBanks.destroy');
    Route::post('cap-nhat-ma-giam-gia', 'OrderController@updateCodeSale')->name('code_sale');
    Route::delete('quan-li-giam-gia/{orderCodeSales}', 'OrderController@deleteCodeSale')->name('orderCodeSales.destroy');

    Route::post('cap-nhat-phi-ship', 'OrderController@updateShip')->name('cost_ship');
    Route::post('cap-nhat-tinh-diem', 'OrderController@updateSetting')->name('updateSetting');
    Route::delete('quan-li-phi-ship/{orderShips}', 'OrderController@deleteShip')->name('orderShips.destroy');

    Route::post('cai-dat-getfly', 'OrderController@updateSettingGetFly')->name('updateSettingGetFly');
    Route::post('cau-hinh-email', 'OrderController@updateSettingEmail')->name('updateSettingEmail');
    Route::post('kiem-tra-cau-hinh', 'SettingController@testEmail')->name('testEmail');

    Route::get('don-hang', 'OrderController@listOrder')->name('orderAdmin');
    Route::get('export-exel','OrderController@exportToExcel')->name('exportToExcel');
    Route::delete('don-hang/{order}', 'OrderController@deleteOrder')->name('orderAdmin.destroy');
    Route::get('show-don-hang/{order}', 'OrderController@showOrder')->name('orderAdmin.show');

    Route::post('cap-nhat-trang-thai-don-hang', 'OrderController@updateStatusOrder')->name('orderUpdateStatus');

    Route::get('thong-bao', 'ReportController@allreport')->name('report');
    Route::get('da-xem-thong-bao', 'ReportController@seenNotification')->name('seenNotification');
    Route::get('da-doc-thong-bao', 'ReportController@readNotification')->name('readNotification');
    Route::get('thong-bao-day', 'ReportController@pushNotification')->name('pushNotify');

    // quan ly domain and theme
    Route::resource('domains', 'DomainController');
    Route::get('domain-show', 'DomainController@anyDatatables')->name('datatable_domain');

    Route::resource('themes', 'ThemeController');
    Route::get('theme-show', 'ThemeController@anyDatatables')->name('datatable_theme');
    Route::get('active-theme', 'ThemeController@activeTheme')->name('active_theme');
    Route::post('change-theme', 'ThemeController@changeTheme')->name('change_theme');

    Route::resource('group-theme', 'GroupThemeController');
    Route::get('group-theme-show', 'GroupThemeController@anyDatatables')->name('datatable_group_theme');

    Route::resource('group-help-video', 'GroupHelpVideoController');
    Route::get('group-help-video-show', 'GroupHelpVideoController@anyDatatables')->name('datatable_group_help_video');

    Route::resource('help-video', 'HelpVideoController');
    Route::get('help-video-show', 'HelpVideoController@anyDatatables')->name('datatable_help_video');

    Route::post('upload-fanpage', 'PostFanpageController@uploadFanpage')->name('upload_fanpage');
    Route::get('comment-facebook', 'CommentFacebookController@pushComment')->name('comment_facebook');

    Route::post('update-groups', 'FanpageController@updateGroups')->name('update_groups');
    Route::post('update-face-id', 'FanpageController@updateFaceIds')->name('update_facebook_id');
    Route::get('delete-face-id', 'FanpageController@deleteFaceIds')->name('delete_facebook_id');
    Route::post('update-setting-face', 'FanpageController@updateSetting')->name('update_setting_face');
    Route::get('get-post-facebook', 'FanpageController@index')->name('get_post_facebook');


    Route::get('get-uid', 'FacebookUidController@getUid')->name('get_uid');
    Route::get('show-get-uid', 'FacebookUidController@showGetUid')->name('show_get_uid');

    Route::get('show-convert-uid', 'FacebookConvertController@showConvertFromUid')->name('show_convert_uid');
    Route::get('convert-uid', 'FacebookConvertController@convertFromUid')->name('convert_uid');
    Route::post('get-uid-from-excel', 'FacebookConvertController@getUidFromExcel')->name('get_uid_from_excel');

    Route::get('show-request-friend', 'FacebookConvertController@showRequestFriend')->name('show_request_friend');
    Route::get('request-friend', 'FacebookConvertController@requestFriend')->name('request_friend');

    Route::get('download-member', 'FacebookUidController@showMembers')->name('download-member');

    /* lấy từ điền về */
    Route::get('lay-tu-dien', 'GetDictionaryController@index')->name('index_tu_dien');
    Route::get('get-noi-dung-tu-dien', 'GetDictionaryController@htmlDom')->name('get_tu_dien');

});

//dang nhap
Route::group(['prefix'=>'admin', 'namespace'=>'Admin' ],function(){
    Route::get('/','LoginController@showLoginForm');
    Route::get('login','LoginController@showLoginForm')->name('login');
    Route::post('login','LoginController@login');
    Route::get('logout','LoginController@logout');
    Route::post('logout','LoginController@logout')->name('logout');
    //reset password
    Route::get('password/reset','LoginController@getReset');
    Route::post('password/reset','LoginController@postReset');
});

Route::group(['namespace'=>'Site'], function() {
    Route::get('/', 'HomeController@index')->name('home');
    Route::get('/hot-deal', 'ProductCategoryController@index');
    Route::get('/danh-muc/{cate_slug}', 'CategoryController@index')->name('site_category_post');
    Route::get('/cua-hang/{cate_slug}', 'ProductCategoryController@index')->name('site_category_product');
    Route::get('/tim-kiem', 'ProductCategoryController@search')->name('search_product');
    Route::get('/tim-kiem-ajax', 'ProductCategoryController@searchAjax')->name('search_product_ajax');

    // thao tác từ khóa ngoài trang chủ
    Route::get('/show-word-search', 'WordController@search')->name('show_word_search');
    Route::get('/get-detail-word', 'WordController@getDetailWord')->name('get_detail_word');
    Route::get('/delete-word', 'WordController@deleteWord')->name('delete_word');
    Route::get('/clean-word', 'WordController@cleanWord')->name('clean_word');

    Route::get('rating', 'ProductController@Rating')->name('rating');

    Route::get('/bo-sung/{sub_post_slug}', 'SubPostController@index');

    Route::get('/dang-ky','RegisterController@showRegistrationForm')->name('register');
    Route::post('/dang-ky','RegisterController@register');

    Route::post('/quen-mat-khau','PersonController@postReset')->name('forget_password');

app/Http/Controllers/Admin/TypeInformationController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Entity\Domain;
use App\Entity\Theme;
use App\Entity\TypeInformation;
use App\Entity\User;
use App\Ultility\Error;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Log;
use Illuminate\Validation\Rule;
use Mockery\Matcher\Type;
use Validator;
use App\Ultility\Ultility;

class TypeInformationController extends AdminController
{
    protected $role;

    public function __construct()
    {
        parent::__construct();
        $this->middleware(function ($request, $next) {
            $this->role =  Auth::user()->role;

            if (User::isMember($this->role)) {
                return redirect('admin/home');
            }
           
            return $next($request);
        });
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        try {
            $typeInformations = TypeInformation::orderBy('type_infor_id')
                ->get();

            return View('admin.type_information.list', compact('typeInformations'));
        } catch (\Exception $e) {
            Error::setErrorMessage('Lỗi xảy ra khi hiển thị kiểu thông tin: dữ liệu không hợp lệ.');
            Log::error('http->admin->TypeInformationController->index: Lỗi xảy tra trong quá trình hiển thị kiểu thông tin');

            return redirect('admin/home');
        }

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return View('admin.type_information.add');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        try {
            // if slug null slug create as title
            $slug = $request->input('slug');
            if (empty($slug)) {
                $slug = Ultility::createSlug($request->input('title'));
            }

            // excuse input_default
            $typeInput = $request->input('type_input');

            // insert to database
            $typeInformation = new TypeInformation();
            $typeInformation->insert([
                'title' => $request->input('title'),
                'slug' => $slug,
                'type_input' => $typeInput,
                'placeholder' => $request->input('placeholder')
            ]);
        } catch (\Exception $e) {
            Error::setErrorMessage('Lỗi xảy ra khi thêm mới kiểu thông tin: dữ liệu không hợp lệ.');
            Log::error('http->admin->TypeInformationController->store: Lỗi xảy tra trong quá trình thêm mới kiểu thông tin');
        } finally {
            return redirect('admin/type-information');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Entity\TypeInformation  $typeInformation
     * @return \Illuminate\Http\Response
     */
    public function show(TypeInformation $typeInformation)
    {
        return redirect('admin/type-information');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Entity\TypeInformation  $typeInformation
     * @return \Illuminate\Http\Response
     */
    public function edit(TypeInformation $typeInformation)
    {

        return View('admin.type_information.edit', compact('typeInformation'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Entity\TypeInformation  $typeInformation
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, TypeInformation $typeInformation)
    {
        try {
            // if slug null slug create as title
            $slug = $request->input('slug');
            if (empty($slug)) {
                $slug = Ultility::createSlug($request->input('title'));
            }

            // excuse input_default
            $typeInput = $request->input('type_input');

            // update to database
            $typeInformation->update([
                'title' => $request->input('title'),
                'slug' => $slug,
                'type_input' => $typeInput,
                'placeholder' => $request->input('placeholder')
            ]);
        } catch (\Exception $e) {
            Error::setErrorMessage('Lỗi xảy ra khi chỉnh sửa kiểu thông tin: dữ liệu không hợp lệ.');
            Log::error('http->admin->TypeInformationController->update: Lỗi xảy tra trong quá trình chỉnh sửa kiểu thông tin');
        } finally {
            return redirect('admin/type-information');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Entity\TypeInformation  $typeInformation
     * @return \Illuminate\Http\Response
     */
    public function destroy(TypeInformation $typeInformation)
    {
        try {

            TypeInformation::where('type_infor_id', $typeInformation->type_infor_id)->delete();
        } catch (\Exception $e) {
            Error::setErrorMessage('Lỗi xảy ra khi xóa kiểu thông tin: dữ liệu không hợp lệ.');
            Log::error('http->admin->TypeInformationController->destroy: Lỗi xảy tra trong quá trình xóa kiểu thông tin');
        } finally {
            return redirect('admin/type-information');
        }
    }
}

resources/views/admin/type_information/add.blade.php
@extends('admin.layout.admin')

@section('title', 'Thêm mới trường thông tin' )

@section('content')
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <h1>
            Thêm mới Trường dữ liệu thông tin
        </h1>
        <ol class="breadcrumb">
            <li><a href="#"><i class="fa fa-dashboard"></i> Home</a></li>
            <li><a href="#">Cài đặt thông tin</a></li>
            <li class="active">Thêm mới</li>
        </ol>
    </section>

    <section class="content">
        <div class="row">
            <!-- form start -->
            <form role="form" action="{{ route('type-information.store') }}" method="POST">
                {!! csrf_field() !!}
                {{ method_field('POST') }}
                <div class="col-xs-12 col-md-6">
    
                    <!-- Nội dung thêm mới -->
                    <div class="box box-primary">
                        <div class="box-header with-border">
                            <h3 class="box-title">Nội dung</h3>
                        </div>
                        <!-- /.box-header -->

                            <div class="box-body">
                                <div class="form-group">
                                    <label for="exampleInputEmail1">title</label>
                                    <input type="text" class="form-control" name="title" placeholder="Tiêu đề" required>
                                </div>

                                <div class="form-group">
                                    <label for="exampleInputEmail1">slug</label>
                                    <input type="text" class="form-control" name="slug" placeholder="đường dẫn tĩnh" >
                                </div>

                                <div class="form-group">
                                    <label for="exampleInputEmail1">Chú dẫn</label>
                                    <input type="text" class="form-control" name="placeholder" placeholder="Chú dẫn" >
                                </div>



                                <div class="form-group" style="color: red;">
                                    @if ($errors->has('title'))
                                        <label for="exampleInputEmail1">{{ $errors->first('title') }}</label>
                                    @endif
                                </div>
                            </div>
                            <!-- /.box-body -->

                            <div class="box-footer">
                                <button type="submit" class="btn btn-primary">Thêm mới</button>
                            </div>
                    </div>
                    <!-- /.box -->

                </div>

                <div class="col-xs-12 col-md-6">
                    <!-- Nội dung chọn trường dữ liệu -->
                    <div class="box box-primary">
                        <div class="box-header with-border">
                            <h3 class="box-title">Chọn hiển thị chỉnh sửa</h3>
                        </div>
                        <!-- /.box-header -->
                            <div class="box-body">
                                <!-- checkbox -->
                                <div class="form-group">
                                    <label>
                                        <input type="radio" name="type_input" value="one_line" class="flat-red" checked>
                                         Một dòng
                                    </label>
                                </div>
                                <div class="form-group">
                                    <label>
                                        <input type="radio" name="type_input" value="multi_line" class="flat-red">
                                         Nhiều dòng
                                    </label>
                                </div>
                                <div class="form-group">
                                    <label>
                                        <input type="radio" name="type_input" value="editor" class="flat-red">
                                        editor
                                    </label>
                                </div>

                                <div class="form-group">
                                    <label>
                                        <input type="radio" name="type_input" value="image" class="flat-red">
                                        Ảnh
                                    </label>
                                </div>
                            </div>
                            <!-- /.box-body -->
                    </div>
                    <!-- /.box -->
                </div>
            </form>
        </div>
    </section>
@endsection

resources/views/admin/type_information/edit.blade.php
@extends('admin.layout.admin')

@section('title', 'Chỉnh sửa '.$typeInformation->title )

@section('content')
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <h1>
            Chỉnh sửa trường dữ liệu thông tin {{ $typeInformation->title }}
        </h1>
        <ol class="breadcrumb">
            <li><a href="#"><i class="fa fa-dashboard"></i> Home</a></li>
            <li><a href="#">Cài đặt thông tin</a></li>
            <li class="active">Chỉnh sửa</li>
        </ol>
    </section>

    <section class="content">
        <div class="row">
            <!-- form start -->
            <form role="form" action="{{ route('type-information.update', ['type_infor_id' => $typeInformation->type_infor_id]) }}" method="POST">
                {!! csrf_field() !!}
                {{ method_field('PUT') }}
                <div class="col-xs-12 col-md-6">

                    <!-- Nội dung thêm mới -->
                    <div class="box box-primary">
                        <div class="box-header with-border">
                            <h3 class="box-title">Nội dung</h3>
                        </div>
                        <!-- /.box-header -->

                        <div class="box-body">
                            <div class="form-group">
                                <label for="exampleInputEmail1">title</label>
                                <input type="text" class="form-control" name="title" placeholder="Tiêu đề"
                                       value="{{ $typeInformation->title }}" required>
                            </div>

                            <div class="form-group">
                                <label for="exampleInputEmail1">slug</label>
                                <input type="text" class="form-control" name="slug" placeholder="đường dẫn tĩnh"
                                value="{{ $typeInformation->slug }}" />
                            </div>

                            <div class="form-group">
                                <label for="exampleInputEmail1">Chú dẫn</label>
                                <input type="text" class="form-control" name="placeholder" placeholder="chú dẫn"
                                       value="{{ $typeInformation->placeholder }}" />
                            </div>

                            <div class="form-group" style="color: red;">
                                @if ($errors->has('title'))
                                    <label for="exampleInputEmail1">{{ $errors->first('title') }}</label>
                                @endif
                            </div>
                        </div>
                        <!-- /.box-body -->

                        <div class="box-footer">
                            <button type="submit" class="btn btn-primary">Cập nhật</button>
                        </div>
                    </div>
                    <!-- /.box -->

                </div>

                <div class="col-xs-12 col-md-6">
                    <!-- Nội dung chọn trường dữ liệu -->
                    <div class="box box-primary">
                        <div class="box-header with-border">
                            <h3 class="box-title">Chọn hiển thị chỉnh sửa</h3>
                        </div>
                        <!-- /.box-header -->
                        <div class="box-body">
                            <!-- checkbox -->
                            <div class="form-group">
                                <label>
                                    <input type="radio" name="type_input" value="one_line" class="flat-red" @if(strpos($typeInformation->type_input, 'one_line') !== false) checked @endif>
                                    Mộ dòng
                                </label>
                            </div>

                            <div class="form-group">
                                <label>
                                    <input type="radio" name="type_input" value="multi_line" class="flat-red" @if(strpos($typeInformation->type_input, 'multi_line') !== false) checked @endif>
                                    Nhiều dòng dòng
                                </label>
                            </div>

                            <div class="form-group">
                                <label>
                                    <input type="radio" name="type_input" value="editor" class="flat-red" @if(strpos($typeInformation->type_input, 'editor') !== false) checked @endif>
                                    Editor
                                </label>
                            </div>

                            <div class="form-group">
                                <label>
                                    <input type="radio" name="type_input" value="image" class="flat-red"
                                           @if(strpos($typeInformation->type_input, 'image') !== false) checked @endif/>
                                    Ảnh
                                </label>
                            </div>

                        </div>
                        <!-- /.box-body -->
                    </div>
                    <!-- /.box -->
                </div>
            </form>
        </div>
    </section>
@endsection

resources/views/admin/type_information/list.blade.php
@extends('admin.layout.admin')

@section('title', 'Danh sách trường thông tin' )

@section('content')
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <h1>
            Cài đặt thông tin
        </h1>
        <ol class="breadcrumb">
            <li><a href="#"><i class="fa fa-dashboard"></i> Home</a></li>
            <li><a href="#">Danh sách trường dữ liệu</a></li>
        </ol>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-xs-12">
                <div class="box">
                    <div class="box-header">
                        <a  href="{{ route('type-information.create') }}"><button class="btn btn-primary">Thêm mới</button> </a>
                    </div>
                    <!-- /.box-header -->
                    <div class="box-body">
                        <table id="example1" class="table table-bordered table-striped">
                            <thead>
                            <tr>
                                <th width="5%">STT</th>
                                <th width="5%">ID</th>
                                <th>Tiêu đề</th>
                                <th>Slug</th>
                                <th>Placeholder</th>
                                <th>Thao tác</th>
                            </tr>
                            </thead>
                            <tbody>
                            @foreach($typeInformations as $id => $typeInformation )
                                <tr>
                                    <td>{{ ($id+1) }}</td>
                                    <td>{{ $typeInformation->type_infor_id }}</td>
                                    <td>{{ $typeInformation->title }}</td>
                                    <td>{{ $typeInformation->slug }}</td>
                                    <td>{{ $typeInformation->placeholder }}</td>
                                    <td>
                                        <a href="{{ route('type-information.edit', ['type_infor_id' => $typeInformation->type_infor_id]) }}">
                                            <button class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i></button>
                                        </a>
                                        <a  href="{{ route('type-information.destroy', ['type_infor_id' => $typeInformation->type_infor_id]) }}" class="btn btn-danger btnDelete" data-toggle="modal" data-target="#myModalDelete" onclick="return submitDelete(this);">
                                            <i class="fa fa-trash-o" aria-hidden="true"></i>
                                        </a>
                                    </td>
                                </tr>
                            @endforeach
                            </tbody>
                            <tfoot>
                            <tr>
                                <th>STT</th>
                                <th>ID</th>
                                <th>Tiêu đề</th>
                                <th>Slug</th>
                                <th>Placeholder</th>
                                <th>Thao tác</th>
                            </tr>
                            </tfoot>
                        </table>
                    </div>
                    <!-- /.box-body -->
                </div>
                <!-- /.box -->
            </div>
        </div>
    </section>
    @include('admin.partials.popup_delete')
@endsection